unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TMsgHeader = record
    /// HEADER PESAN  ///
    onBottom : Boolean;
    Msg : string;
    FormColor : TColor; { = Integer }
    FontName  : String;
    FontSize  : integer;
    FontStyle : TFontStyles;
    FontColor : TColor;
    Loop      : Byte;   // banyaknya pengulangan /looping (minimal 1 )
    Speed     : Byte;
  end;

type
  TFMain = class(TForm)
    Timer1: TTimer;
    LInfo1: TLabel;
    Timer3: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
  private
    { Private declarations }
    W,H : integer;
    Font1  : TFont;

    // Batas kanan Label 1,2 dan 3
    ir1  : integer;
    Loop : Byte;
    Speed    : byte;

    /// Timer 3 var
    x1,x2 : Integer;
    RGN1 : HRGN;
    Tampil : boolean;

    procedure SetPosition(onBottom : Boolean);
    procedure HideProgram;
  public
    { Public declarations }
  published
    procedure AktifkanPesan(Aktif : Boolean);
  end;

const
  ID = '';

var
  FMain : TFMain;
  Pesan : TMsgHeader;


implementation


{$R *.dfm}

// Mendapatkan Ukuran Taskbar
function GetTaskBarSize: TRect;
var
  wnd: HWND;
begin
  wnd := FindWindow('Shell_TrayWnd', nil);
  if wnd > 0 then
    GetWindowRect(wnd, Result)
  else
    Result := Rect(0, 0, 0, 0);
end;

procedure TFMain.AktifkanPesan(Aktif: Boolean);
begin
  with FMain do
  begin
    Font1.Name := Pesan.FontName;
    Font1.Color := Pesan.FontColor;
    Font1.Size := Pesan.FontSize;
    Font1.Style := Pesan.FontStyle;
    Color := Pesan.FormColor;
    LInfo1.Caption := Pesan.Msg;
    Loop := Pesan.Loop;
    Speed := Pesan.Speed;
    if Pesan.Speed < 5 then Speed :=20;  // nilai 5-255 milidetik
    Timer1.Interval := Speed;

    Linfo1.Left := W;
    LInfo1.AutoSize := True;
    LInfo1.Font := Font1;
    LInfo1.Font.Color := Pesan.FontColor;
    FMain.Height := LInfo1.Canvas.TextHeight('Ej|')+6;
    SetPosition(Pesan.onBottom);
    FMain.Visible := True;
  end;
end;

procedure TFMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled := False;
  Font1.Free;
  DeleteObject(RGN1);
end;

// Set Posisi Pesan
Procedure TFmain.SetPosition(onBottom : Boolean);
var
  r : TRect;
begin
  // Width and Height of Screen
  W := screen.Width;
  H := screen.Height;
  // Get Taskbar Size
  if onBottom then  r := GetTaskBarSize;

  Fmain.BorderStyle := bsNone;
  Fmain.Left  :=0;
  FMain.Width := W;

  if onBottom then
    Fmain.Top := r.Top - FMain.Height
  else
    FMain.Top := 0;
end;

procedure TFMain.FormCreate(Sender: TObject);
begin
  SetPosition(False);

  Font1 := TFont.Create;
  
  LInfo1.Top := 3;
  LInfo1.caption := '';

  // Untuk menghilangkan ficker
  FMain.DoubleBuffered := True;
end;

Procedure TFMain.HideProgram;
begin
  Timer3.Enabled := True;
  Tampil := false;
  Timer1.Enabled := False;
end;

procedure TFMain.FormPaint(Sender: TObject);
begin
  if trim(Linfo1.Caption) = '' then
  begin
    Timer1.Enabled := false;
    Fmain.Visible := false;
  end
end;

Procedure TFMain.Timer1Timer(Sender: TObject);
begin
  ir1 := LInfo1.Left+Linfo1.Width;
  if ir1 <= 0 then
  begin
    Dec(loop);
    if Loop <= 0 then HideProgram;
    LInfo1.Left := W;
  end;
  LInfo1.Left := LInfo1.Left-1;
end;

procedure TFMain.Timer3Timer(Sender: TObject);
begin
  if Tampil then
  begin
    if (x2-x1) <= FMain.Height then
    begin
      x2 := x2+1;
      x1 := x1-1;
      RGN1 := CreateRectRgn(FMain.left,x1,FMain.Width,x2);
      SetWindowRgn(FMain.Handle,RGN1,True);
    end
    else
      Timer3.Enabled := false;
  end
  else
  begin
    if (x2-x1) > 0 then
      begin
        x2 := x2-1;
        x1 := x1+1;
        RGN1 := CreateRectRgn(FMain.left,x1,FMain.Width,x2);
        SetWindowRgn(FMain.Handle,RGN1,True);
      end
    else
        FMain.Visible := False;
  end;
end;

procedure TFMain.FormHide(Sender: TObject);
begin
  Timer1.Enabled := False;
  Timer3.Enabled := False;
  Loop := 0;
end;

procedure TFMain.FormShow(Sender: TObject);
begin
  // Animasi saat window tampil..
  x1 := FMain.Height div 2;
  x2 := x1;
  RGN1 := CreateRectRgn(0,0,0,0);
  SetWindowRgn(FMain.Handle,RGN1,True);
  Tampil := True;
  Timer1.Enabled := True;
  Timer3.Enabled := True;
  if loop < 1  then Loop :=1;
end;

end.
